//==============================================================
// ͊֘A
// STEAR 2009
//--------------------------------------------------------------
// ėpPĆB
//--------------------------------------------------------------

#include <pspuser.h>
#include <pspctrl.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "smemo.h"
#include "graphics.h"
#include "zenkaku.h"
#include "draw.h"
#include "sime.h"
#include "strInput.h"

#define	LISTMAX		(20)										// ͗ɕۊǂől


//==============================================================
// ͗̑S폜
//--------------------------------------------------------------
// inphis ͗
//--------------------------------------------------------------
// ͗p̃܂B
//--------------------------------------------------------------

void InputHisFree(strInpHis **inphis)
{
	strInpHis	*inphis2,*inphis3;

	if (!inphis) return;
	if (!*inphis) return;

	inphis3 = *inphis;
	while (inphis3){
		inphis2 = inphis3->chain;
		free(inphis3->text);
		free(inphis3);
		inphis3 = inphis2;
	}
	free(inphis);
}

//==============================================================
// ͗̓ǂݍ
//--------------------------------------------------------------
// path   ͗t@C
// ߂l ͗ւ̃|C^
//--------------------------------------------------------------
// ͗p̃mۂAwt@C̗ZbgB
// t@Cǂ߂Ȃꍇ̓mۂ܂B
// œ͗p̃mۂȂƓ͗@\g܂B
//--------------------------------------------------------------

strInpHis **InputHisLoad(char *path)
{
	strInpHis	**inphis,*inphis2,*inphis3;
	char	*data;
	int		fd,pos,count;
	long	filesize;

	inphis = (strInpHis**) malloc( sizeof(strInpHis*) );
	if (!inphis) return (NULL);
	*inphis = NULL;

	fd = sceIoOpen( path, PSP_O_RDONLY, 0777 );
	if (fd<0) return (inphis);
	filesize = sceIoLseek(fd, 0, SEEK_END);
	sceIoLseek(fd, 0, SEEK_SET);
	data = (char*) malloc( filesize );							// t@CTCY͂1000oCgxȂ̂
	if (!data){
		sceIoClose(fd);
		return (inphis);
	}
	sceIoRead( fd, data, filesize );
	sceIoClose(fd);

	pos = 0;
	count = 0;
	inphis3 = NULL;
	while (pos<filesize && count<LISTMAX){
		inphis2 = (strInpHis*) malloc( sizeof(strInpHis) );
		if (!inphis2) break;
		inphis2->text = (char*) malloc( strlen(&data[pos])+1 );
		if (!inphis2->text){
			free(inphis2);
			break;
		}
		strcpy( inphis2->text,&data[pos] );
		inphis2->chain = NULL;
		inphis2->save = 0;										// ꂪ1ɂȂύX
		if (!inphis3){											// ŏ̃Xg
			*inphis = inphis2;
		} else {												// QԖڈȍ~̃Xg
			inphis3->chain = inphis2;
		}
		inphis3 = inphis2;
		pos += strlen(&data[pos]) +1;
		count++;
	}
	free(data);
	return (inphis);
}

//==============================================================
// ͗̕ۑ
//--------------------------------------------------------------
// path   ͗ۑt@C
// inphis ͗
//--------------------------------------------------------------
// eɕύXꍇ̂ݕۑ܂B
//--------------------------------------------------------------

void InputHisSave(char *path,strInpHis **inphis)
{
	strInpHis	*inphis2;
	int		fd;

	if (!inphis) return;
	if (!*inphis) return;

	inphis2 = *inphis;
	if (!inphis2->save) return;									// ɕύXȂ
	fd = sceIoOpen( path, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777 );
	if (fd<0) return;
	while (inphis2){
		sceIoWrite( fd, inphis2->text, strlen(inphis2->text)+1 );
		inphis2 = inphis2->chain;
	}
	sceIoClose(fd);
}

//==============================================================
// ͗ɃXgǉ
//--------------------------------------------------------------
// eꍇ͓do^͂ȂB
// 擪ʒuɓo^܂B
// Xg̐LISTMAX𒴂ꍇ͈ԌÂXg폜܂B
// 擾oȂꍇ͉܂B
//--------------------------------------------------------------

//----- Xgɒǉ -----

static void InputHisAddSub(strInpHis **inphis2,char *text)
{
	strInpHis	*inphis;

	inphis = (strInpHis*) malloc( sizeof(strInpHis) );
	if (inphis){
		inphis->text = (char*) malloc( strlen(text)+1 );
		if (!inphis->text){										// ep̊mۂɎs
			free(inphis);
		} else {												// Ƀmۂł
			strcpy( inphis->text,text );
			inphis->chain = *inphis2;
			inphis->save = 1;									// ύXꂽ
			*inphis2 = inphis;
		}
	}
}

//----- C -----

static void InputHisAdd(strInpHis **inphis,char *text)
{
	strInpHis	*inphis2,*inphis3;
	int		count;

	if (!inphis) return;

	if (!*inphis){												// ŏ̈
		InputHisAddSub( inphis, text );
		return;
	}

	inphis2 = *inphis;
	inphis3 = NULL;
	while (inphis2){											// e邩
		if (!strcmp(inphis2->text,text)) break;
		inphis3 = inphis2;
		inphis2 = inphis2->chain;
	}
	if (inphis2){												// e
		if (inphis3){											// ʒuQԖڈȍ~Ȃ
			inphis3->chain = inphis2->chain;					// `FCO
			inphis3 = *inphis;
			*inphis = inphis2;
			inphis2->save = 1;									// ɕύX
			inphis2->chain = inphis3;							// ԍŏֈړ
		}
	} else {													// VKǉ
		InputHisAddSub( inphis, text );
		count = 0;
		inphis2 = *inphis;
		while (inphis2 && count<LISTMAX){						// Xǧ𐔂
			count++;
			inphis3 = inphis2;
			inphis2 = inphis2->chain;
		}
		if (inphis2){											// 𒴂Ă
			inphis3->chain = NULL;								// 폜
			free(inphis2->text);
			free(inphis2);
		}
	}
}

//==============================================================
// ͗烊Xgڂ擾
//--------------------------------------------------------------
// text   擾ꂽXgei͗j
// size   text̃TCY
// inphis ͗
// index  oXg̈ʒu
// ߂l 擾ꂽXg̎ۂ̈ʒui擪ʒu0j
//--------------------------------------------------------------
// ꍇtext̓eɕῶ܂B
// ̖̎߂l-1łB
// ̃Xg𒴂ʒuw肳ꂽꍇAŌ̃XgeԂ܂B
//--------------------------------------------------------------

static int InputHisGet(char *text,int size,strInpHis **inphis,int index)
{
	strInpHis	*inphis2;
	int		i,pos;

	if (!inphis) return (-1);
	if (!*inphis) return (-1);
	if (index<0) return (-1);

	inphis2 = *inphis;
	for (i=0; i<index ;i++){									// wʒuT
		if (!inphis2->chain) break;								// Xgs
		inphis2 = inphis2->chain;
	}
	for (pos=0; pos<size-1 ;pos++){								// obt@I[o[t[΍
		text[pos] = inphis2->text[pos];
	}
	text[pos] = '\0';
	return (i);
}


//==============================================================
// Sp/p肠ňꕶ
//--------------------------------------------------------------

static int INBack(char *str,int pos)
{
	int pos2,step;

	if (pos>0){
		pos2 = 0;
		while (1){
			if (chkSJIS(str[pos2])){
				step = 2;
			} else {
				step = 1;
			}
			if (pos2+step>=pos) break;
			pos2 += step;
		}
		pos = pos2;
	}
	return (pos);
}

//==============================================================
// 
//--------------------------------------------------------------
// title   ^Cg
// size    ͗̕iő50܂Łj
// ime     ̓\[Xi0:Simple IME ȊO:OSKj
// inStr   ͕̏l
// outStr  ͌
// inphis  ͗
// ߂l     0:{^ŏI
//         ȊO:~{^ŃLZꂽ
//--------------------------------------------------------------
// ėpPC͂łB
// _CAOʒu͎wł܂B
// {^ŏIꍇAoutStrɓ͕񂪕ԂB
// ~{^ŏIꍇAoutStrɂinStrԂB
// _CAO̔wi͕Ȃ̂ŁAKvɉČĂяoōĕ`ʂsĂB
//--------------------------------------------------------------

int InputName(char *title,int size,int ime,char *inStr,char *outStr,strInpHis **inphis)
{
	SceCtrlData pad;
	char	str[64],cr[128];
	int		i,cx,cy,x,pos,len,p,dr,end,font,index;

	if (size>50) size = 50;

	font = SIMEfont( 0, 12 );									// SIMẼtHg𓌉_tHg

	//----- _CAO\z -----

	DialogFrame( 78, 70, 24+300, 57, title, ":͗  :  ~:ݾ", gSCor[1], gSCor[2] );
	x = 78 + 324/2 - (size*6+2)/2;								// ͗ʒu
	BoxFill(  x, 91, size*6+2, 14, 0, 0 );
	x += 1;
	cy = 92;
	strcpy( str, inStr );										// ̏l
	len = strlen(str);
	pos = len;
	mh_print( x, cy, str, gSCor[0] );

	//----- ͏ -----

	end = 1;
	index = -1;
	while (!gExitRequest && end){
		cx = x + pos * 6;
		SIMEcursor( 2, cx, cy );								// J[\̈ʒuw
		sceCtrlReadBufferPositive( &pad,1 );
		SIMEselInput( ime, cr, pad );
		if (cr[0]!=0){											// ͂
			dr = 0;												// 邩i0:Noj
			if (cr[0]<32U || cr[0]==0x7F){						// Rg[R[hꍇ
				switch(cr[0]){
				case SIME_KEY_CIRCLE:							//  [Enter]
					InputHisAdd( inphis,str );
					end = 0;
					break;
				case SIME_KEY_CROSS:							// ~ [ESC]
					end = 0;
					break;
				case SIME_KEY_UP:								// i͗j
					if (index>-1) index--;
					index = InputHisGet( str, size, inphis, index );
					if (index>=0){
						len = strlen(str);
						pos = len;
						dr = 1;
					} else {
						str[0] = '\0';
						len = 0;
						pos = 0;
						dr = 1;
					}
					break;
				case SIME_KEY_DOWN:								// i͗j
					index++;
					index = InputHisGet( str, size, inphis, index );
					if (index>=0){
						len = strlen(str);
						pos = len;
						dr = 1;
					}
					break;
				case SIME_KEY_LEFT:								// 
					pos = INBack( str, pos );
					break;
				case 0x08:										// [BS]
				case 0x7F:										// [DEL]
					if (len>0){
						if (cr[0]==0x08){
							pos = INBack( str, pos );
						}
						if (chkSJIS(str[pos])){
							strcpy( &str[pos], &str[pos+2] );
							len -= 2;
						} else {
							strcpy( &str[pos], &str[pos+1] );
							len -= 1;
						}
						dr = 1;
					}
					break;
				case SIME_KEY_RIGHT:							// 
					if (chkSJIS(str[pos])){
						pos += 2;
					} else {
						if (pos<len){
							pos++;
						}
					}
					break;
				}
			} else {											// ꍇ
				p = 0;
				while (cr[p]!='\0'){
					if (chkSJIS(cr[p])){						// Sp
						if (len<=size-2){
							for (i=0; i<len-pos ;i++)
								str[len-1+2-i] = str[len-1-i];
							str[pos++] = cr[p++];
							str[pos++] = cr[p++];
							len += 2;
							dr = 1;
						} else {
							break;
						}
					} else if (cr[p]>=32){						// p
						if (len<=size-1){
							for (i=0; i<len-pos ;i++)
								str[len-1+1-i] = str[len-1-i];
							str[pos++] = cr[p++];
							len += 1;
							dr = 1;
						} else {
							break;
						}
					} else {									// Rg[R[h͖
						p++;
					}
				}
				str[len] = '\0';
			}
			if (dr){											// ̍XV
				BoxClr( x, cy, size*6, 12 );
				mh_print( x, cy, str, gSCor[0] );
			}
		}

		sceDisplayWaitVblankStart();
		ScreenView();
	}

	SIMEfont(font,(font==2 ? 16 : 12));							// SIMEtHgɖ߂

	//----- ߂l -----

	if (cr[0]==0x0D){											// [Enter]ŏIĂ
		strcpy( outStr, str );
		return (0);
	} else {
		strcpy( outStr, inStr );
		return (-1);
	}
}

